/*
 * DIP-SW Test
 *
 * This Program is CG-LBSTD2PU (ADM5120) Only.
 */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/select.h>
#include <ctype.h>
#include "diptest.h"

/* ADM5120 SWITCH Register Base Address */
#define ADM5120_SWITCH_BASE	0x12000000
#define ADM5120_SCR_SIZE	0x1000
#define SCR_GPIO_CONF0          0xb8
#define PORT_DIPSW_B1_BIT       0x0100
#define PORT_DIPSW_B2_BIT       0x0200
#define PORT_DIPSW_B3_BIT       0x0400
#define PORT_DIPSW_B4_BIT       0x0800

#define PORT_DIPSW_B1_ENB       0
#define PORT_DIPSW_B2_ENB       0
#define PORT_DIPSW_B3_ENB       0
#define PORT_DIPSW_B4_ENB       0

static void *EthMapPointer = (void *) -1;
static int EthMapFD = -1;

unsigned short GetDipSw(void)
{
        unsigned long PortDa;
        unsigned short DipSw;

        PortDa = *(volatile unsigned long *)(EthMapPointer + SCR_GPIO_CONF0);
        DipSw = 0;
        if((PortDa & PORT_DIPSW_B1_BIT) == PORT_DIPSW_B1_ENB ){ DipSw |= 0x01;  }
        if((PortDa & PORT_DIPSW_B2_BIT) == PORT_DIPSW_B2_ENB ){ DipSw |= 0x02;  }
        if((PortDa & PORT_DIPSW_B3_BIT) == PORT_DIPSW_B3_ENB ){ DipSw |= 0x04;  }
        if((PortDa & PORT_DIPSW_B4_BIT) == PORT_DIPSW_B4_ENB ){ DipSw |= 0x08;  }
        return( DipSw );
}

int main(int argc, char *argv[])
{

	int rtn = 0,rtn1=0;
    if( EthMapFD != -1) close(EthMapFD);
    EthMapFD = open("/dev/mem" , O_RDWR);
    if( EthMapFD == -1 ) {
	    perror("/dev/mem");
	    exit(-1);
    }
    EthMapPointer =
	    mmap(NULL,ADM5120_SCR_SIZE,PROT_READ|PROT_WRITE,MAP_SHARED,
			    EthMapFD,ADM5120_SWITCH_BASE);
    if (EthMapPointer == (void *) -1) {
	    perror("mmap()");
	exit(1);
    }

    while(1) {
	    rtn = GetDipSw();
	    if(rtn != 0) {
		    if( rtn != rtn1 )
	      		printf("DIP-SW %d\n", rtn);
	      rtn1 = rtn;
	    }

    }

    exit(0);
}
